#!/usr/bin/perl
#
# File:  "$Id: m2kpatch.pl,v 1.2 2009/04/23 11:18:07 jonas_liu Exp $"
#
# Description:
#
# BUGS:
#
# CHANGES:
#
# NOTE:
#
# First Created on  by
# Last Modified on "$Date: 2009/04/23 11:18:07 $" by  $Author: jonas_liu $
#
# Copyright (c)2008 Openfind Information Technology INC.
# All rights reserved.
#

use Time::Local;

my $CVSREV = '$Revision: 1.2 $';
my $CVSID = substr($CVSREV, 11, -2);

$VENDOR = "Openfind";
$VERSION = "Mail2000 patch program v$CVSID";

$OWNER = "webmail";
$GROUP = "webmail";
$OwnerUid = 0;
$GroupGid = 0;

$M2K_PATCH_INFO = "/webmail/etc/m2kpatch.info";
$M2K_PATCH_VER = "";
$CP = "/bin/cp -p";

$time = time;
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($time);

$mon++;
$year -= 100;
my $date = "";
$date = sprintf(".%02d%02d%02d.%02d%02d", $year, $mon, $mday, $hour, $min);

system("clear");
print STDOUT "$VERSION\n";

###############################################################
# Check the uid of install program
###############################################################

printf STDOUT "%s...","Checking Permissions";

#if ( $< != 0 ) {
#	printf STDOUT "[X]Please run as root!\n";
#	exit(1);
#}
printf STDOUT "done.\n";

###############################################################
# Checking User/Group
###############################################################
printf("Checking User/Group...");
if ( !($OwnerUid=getpwnam($OWNER)) || ($GROUP ne "" && !($GroupGid=getgrnam($GROUP))) ) {
	printf("[X]User(%s)/Group(%s) does not exist\n", $OWNER, $GROUP);
	exit(11);
}
printf("done.\n");

if ("$<" ne $OwnerUid) { 
	printf("Please run patch tool with $OWNER\n"); 
	exit(12);
}

printf("Checking patch info file...");
if(-e $M2K_PATCH_INFO && ! -w $M2K_PATCH_INFO) {
	printf("\n\n[ERROR] Please check owner and permission of $M2K_PATCH_INFO\n\n");
	exit(15);
}
printf("done.\n");

###############################################################
#  check m2kpkg.lst
###############################################################

if (!-f "./m2kpkg.lst") {
	print STDOUT "[X]Please make sure m2kpkg.lst exists!\n";
	exit;
}

open (IN, "<m2kpkg.lst") or die "can't open m2kpkg.lst!\n";
my @lines = <IN>;
close(IN);

$i = 0;
foreach my $line (@lines) {
	chomp($line);
	if ( ($i == 0) && ($line !~ /^%/) ) {
		printf STDOUT "[X]error format of m2kpkg.lst!\n";
		exit;
	}
	elsif ( ($i == 0) && ($line =~ /^%/) ) {
		###############################################################
		#  check previous patch
		###############################################################
		$M2K_PATCH_VER = $line;
		$M2K_PATCH_VER =~ s/^%//;
		my @args = split(/ /, $line);
		for (my $j=1; $j <= $#args; $j++) {
			if (0 != chk_prev_patch("$args[$j]")) {
				printf STDOUT "[X]Please install $args[$j]!\n";
				exit;
			}
		}
		$i++;
		next;
	}
	if ($line =~ /^#/) {
		###############################################################
		#  print message to stdout
		###############################################################
		$line =~ s/^#\s*//;
		print STDOUT $line . "\n";
	}
	elsif ($line =~ /^@/) {
		###############################################################
		#  execute command line
		###############################################################
		$line =~ s/^@//;
		my @output = `$line > /dev/null 2>&1`;
	}
	elsif ($line =~ /^\$@/) {
		$line =~ s/^\$@//;
		@args = split(/\t/, $line);
		$cond = $args[0];
		$cmd = $args[1];
		$func_str = 'sub { if(' . $cond . '){ return 1;}else{ return 0;}}';
		$func = eval($func_str);
		if (&$func()) { 
			my @output = `$cmd > /dev/null 2>&1`;
		}
	}
	elsif ($line =~ /^\$Z/) {
		$line =~ s/^\$Z//;
		@args = split(/\t/, $line);
		$cond_prog = $args[0];
		$cmd = $args[1];

		if(system($cond_prog) != 0) {
			my @output = `$cmd > /dev/null 2>&1`;
		}
	}
	elsif ($line =~ /^\$\$/) {
		$line =~ s/^\$\$//;
		@args = split(/\t/, $line);
		$cond = $args[0];
		$note = $args[1];
		$func_str = 'sub { if(' . $cond . '){ return 1;}else{ return 0;}}';
		$func = eval($func_str);
		if(&$func()) {
			print "$note\n";
			exit;
		}
	}
	else { 
		$bUseCond = 0;
		if ($line =~ /^\$/) { 
			$bUseCond = 1; 
			$line =~ s/^\$//;
		}

		###############################################################
		#  copy file
		###############################################################
		@args = split(/\t/, $line);
		if ($bUseCond) { 
			$cond = $args[0]; 
			$func_str = 'sub { if(' . $cond . '){return 1;}else{return 0;}}'; 
			$func = eval($func_str); 
			next if (&$func() != 1);
			$src = $args[1];
			$des = $args[2];
			$bak = $args[3];
		} else {
			$src = $args[0];
			$des = $args[1];
			$bak = $args[2];
		}

		if ($#args > 1) {
			###############################################################
			#  check backup file of directory is exists or not
			###############################################################
			dir_check("$bak");
			$bak .= $date;
			###############################################################
			#  backup file
			###############################################################
			if (0 != system("$CP $des $bak")) {
				printf STDOUT "[X]Fail copy from $des to $bak!\n";
				exit;
			}
		}
		###############################################################
		#  update file
		###############################################################
		if (0 != system("$CP $src $des")) {
			printf STDOUT "[X]Fail copy from $src to $des!\n";
			exit;
		}
	}
	$i++;
}

###############################################################
#  update /webmail/etc/m2kpatch.info
###############################################################
if(open(OU, ">> $M2K_PATCH_INFO")) {
	$date = sprintf("%04d/%02d/%02d %02d:%02d:%02d", $year + 2000, $mon, $mday, $hour, $min, $sec);
	print OU "$M2K_PATCH_VER\t$date\n";
	close(OU);
}
else {
	print STDOUT "[WARNING] cannot update patch info: $M2K_PATCH_INFO.";
}
system("/webmail/tools/restartshm");

###############################################################
# Check previous patch is install or not
# check /webmail/etc/m2kpatch.info
###############################################################
sub chk_prev_patch()
{
	my ($patch) = @_;
	print STDOUT "checking [$patch]...";
	if (!-f "$M2K_PATCH_INFO") {
		printf STDOUT "ERROR!\n";
		return 0;
	}
	open (IN, "</webmail/etc/m2kpatch.info") or die "can't open /webmail/etc/m2kpatch.info";
	my $line;
	my $exist = 0;
	while($line = <IN>) {
		chomp($line);
		my ($ver, $date) = split(/\t/, $line);
		if ($ver eq "$patch") {
			$exist = 1;
			last;
		}
	}
	close(IN);
	if ($exist == 0) {
		printf STDOUT "ERROR!\n";
		return -1;
	}
	printf STDOUT "done!\n";
	return 0;
}

########################################################
# if directory is not exist then create it
########################################################
sub dir_check()
{
	my ($fpath) = @_;

	@dirs = split(/\//, $fpath);
	for (my $i = 1; $i < $#dirs; $i++) {
		my $ldir = "";
		for (my $j = 1; $j <= $i; $j++) {
			$ldir .= "/$dirs[$j]";
		}
		if (!-d $ldir) {
			printf STDOUT "Creating Direcotry %s.....", $ldir;
			if ( mkdir($ldir, 0750) == 0 && !-d $ldir) {
				printf STDOUT "[X]cannot build directory %s(%s)\n", $ldir, $!;
				exit(3);
			}
			chown($OwnerUid, $GroupGid, $ldir);
			printf STDOUT "done.\n";
		}
	}
	return 0;
}
